Sunday, September 8, 2013

Longest Consequent Sequence@leetcode

刷题必备书籍Cracking the Coding Interview: 150 Programming Questions and Solutions 

简历:The Google Resume: How to Prepare for a Career and Land a Job at Apple, Microsoft, Google, or any Top Tech Company
算法学习书籍:Introduction to Algorithms
编程珠玑:Programming Pearls (2nd Edition)
C++ 学习:The C++ Programming Language, 4th Edition
经典操作系统书籍,龙书:Operating System Concepts
创业:The Start-up of You: Adapt to the Future, Invest in Yourself, and Transform Your Career
Given an unsorted array of integers, find the length of the longest consecutive elements sequence.
For example,
Given [100, 4, 200, 1, 3, 2],
The longest consecutive elements sequence is [1, 2, 3, 4]. Return its length: 4.
Your algorithm should run in O(n) complexity.
» Solve this problem

Because it has to be solved in O(n) time. Thus, normal sorting algorithm cannot be applied here. So hashmap came to my mind, to quick allocate the element.

Algorithm:
1. Create a hashmap to store the given sequence
2. Create a vector to mark visited elements and avoid duplicate search
3. search num[i] +1 and num[i]-1 iteratively, and set count.
4. Return the longest length we found.


1 comment:

  1. you solution is not O(n),

    since a single elements might get visited many times unless you remove them from hashmap when you visit them first time.

    ReplyDelete

Leetcode 316. Remove Duplicate Letters

 这道题表面问的是如何删除重复,实际在问如何从多个字符选取一个保留,从而让整个字符串按升序排列。那么策略就是对于高顺位的字符比如‘a',就要选靠前位置的保留,而低顺位字符如’z'则应该尽量选取靠后位置保留。 算法大概思路:每看到一个字符,我们要决定是否保留 1. ...